﻿#DWMWA_EXTENDED_FRAME_BOUNDS = 9
#CAPTUREBLT  = $40000000

Enumeration
  #c_alt
  #c_win
  #c_shift
  #c_ctrl
  #b_ok
EndEnumeration

Global TaskbarRestart = RegisterWindowMessage_("TaskbarCreated")  ; Register a message with the "TaskbarCreated" string
Global hicon.l
Global war.l=0 ;winamp rule
Global spa.s ;savepath

#HotKeyGadget = 99 ; or whatever, just remember this is a #gadget so don't reuse it

InitSound()
CatchSound(0,?cl)

Procedure.l WindowCallback(hwnd,message,wparam,lparam)
Protected result.l=#PB_ProcessPureBasicEvents
 Select message
  Case taskbarrestart
   AddSysTrayIcon (1, WindowID(0), hicon)
 EndSelect
ProcedureReturn result
EndProcedure

Procedure reg_wa()
              If Not RegisterHotKey_(WindowID(0),3,#MOD_WIN|#MOD_CONTROL,#VK_S)
                MessageRequester("Hotkey Winamp","Cannot register hotkey win+S")
              EndIf
              If Not RegisterHotKey_(WindowID(0),4,#MOD_WIN|#MOD_CONTROL,#VK_RIGHT)
                MessageRequester("Hotkey Winamp","Cannot register hotkey win+arrow right")
              EndIf
              If Not RegisterHotKey_(WindowID(0),5,#MOD_WIN|#MOD_CONTROL,#VK_LEFT)
                MessageRequester("Hotkey Winamp","Cannot register hotkey win+arrow right")
              EndIf
EndProcedure

If OpenWindow(0, 100, 200, 200, 60, "Window Maximizer 2.3",#PB_Window_Invisible|#PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget);,#PB_Window_BorderLess|#PB_Window_Invisible);| #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget) 
  SetWindowCallback(@WindowCallback(),0)
  hwndHot = CreateWindowEx_(0,"msctls_hotkey32","",#WS_CHILD|#WS_VISIBLE,0,0,200,20,WindowID(0),#HotkeyGadget,GetModuleHandle_(0),0)
  
  CheckBoxGadget(#c_alt,0,20,40,20,"Alt")
  CheckBoxGadget(#c_win,40,20,40,20,"Win")
  CheckBoxGadget(#c_shift,80,20,40,20,"Shift")
  CheckBoxGadget(#c_ctrl,120,20,40,20,"Ctrl")
  ButtonGadget(#b_ok,0,40,200,20,"OK")
  If CreatePopupMenu(0) 
    MenuItem(1, "setup") 
    MenuItem(3, "winamp remote") 
    MenuBar() 
    MenuItem(2, "Quit") 
  EndIf  
  
  hint.s=""
  hicon=LoadIcon_(GetModuleHandle_(0),1)
  AddSysTrayIcon (1, WindowID(0), hicon)
  
  If ReadFile(0,"mw.dat")
    war.l=ReadLong(0)
    If war
      reg_wa()
      SetMenuItemState(0, 3, war)
    EndIf
    
    vk.l=ReadLong(0)
    mods.l=0
    mods=ReadLong(0)
    hint.s=ReadString(0)
    CloseFile(0)
  Else
    MessageRequester("Settings","File 'mw.dat' not found",#PB_MessageRequester_Ok )
    vk.l=#VK_Z
    mods.l=#MOD_WIN|#MOD_ALT
    hint.s="Win+Alt+Z"
  EndIf
  
  If Not RegisterHotKey_(WindowID(0),0,#MOD_WIN|#MOD_ALT,#VK_Z)
    MessageRequester("Hotkey","Cannot register hotkey"+hint,#PB_MessageRequester_Ok )
    End
  EndIf
  
  If Not RegisterHotKey_(WindowID(0),2,#MOD_WIN,#VK_SNAPSHOT)
    MessageRequester("Hotkey","Cannot register hotkey Win+PrSc",#PB_MessageRequester_Ok )
    End
  EndIf
  
  If CountProgramParameters()
    spa=ProgramParameter(0)
  Else
    spa=""
  EndIf
  
  SysTrayIconToolTip (1, "wnd max 2.3,"+hint)
  Repeat 
    
    EventID.l = WaitWindowEvent() 
    
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      HideWindow(0,1)
    EndIf
    
    Select EventID
      Case #WM_HOTKEY
        
        Select EventwParam()
          Case 5:;left arrow
            hwndWinamp.l = FindWindow_("Winamp v1.x",0)
            If hwndWinamp
              SendMessage_(hwndWinamp,#WM_COMMAND, 40044, 0)
            EndIf
          Case 4:;right arrow
            hwndWinamp.l = FindWindow_("Winamp v1.x",0)
            If hwndWinamp
              SendMessage_(hwndWinamp,#WM_COMMAND, 40048, 0)
            EndIf
          Case 3:;play/pause
            hwndWinamp.l = FindWindow_("Winamp v1.x",0)
            If hwndWinamp
              SendMessage_(hwndWinamp,#WM_COMMAND, 40046, 0)
            EndIf

          Case 0
            hwnd.l=GetForegroundWindow_()
            If hwnd
              ShowWindow_(hwnd,#SW_MAXIMIZE)
            EndIf
          Case 2
            Lib = OpenLibrary(#PB_Any, "dwmapi.dll")
            If lib
              *DwmGetWindowAttribute = GetFunction(Lib, "DwmGetWindowAttribute")
            EndIf
            hwnd.l=GetForegroundWindow_()
            If hwnd
              If OSVersion() >= #PB_OS_Windows_Vista
                lib = OpenLibrary(#PB_Any, "UxTheme.dll")
                If lib
                  *IsThemeActive = GetFunction(lib, "IsThemeActive")
                  If *IsThemeActive
                    Themed = CallFunctionFast(*IsThemeActive)
                  EndIf   
                  CloseLibrary(lib)
                EndIf
                If Themed = 1
                  Lib = OpenLibrary(#PB_Any, "dwmapi.dll")
                  If Lib
                    *DwmIsCompositionEnabled = GetFunction(Lib, "DwmIsCompositionEnabled")
                    If *DwmIsCompositionEnabled
                      CallFunctionFast(*DwmIsCompositionEnabled, @flag)
                    EndIf
                    If flag = 1
                      *DwmGetWindowAttribute = GetFunction(Lib, "DwmGetWindowAttribute")
                      If *DwmGetWindowAttribute                 
                        CallFunctionFast(*DwmGetWindowAttribute, hWnd,  #DWMWA_EXTENDED_FRAME_BOUNDS, wr.RECT, SizeOf(wr))       
                      EndIf
                      shadow = initshadow
                    Else
                      shadow = 0
                      GetWindowRect_(hWnd, wr.RECT)
                    EndIf                   
                  EndIf                 
                  CloseLibrary(Lib)                 
                Else
                  shadow = 0
                  GetWindowRect_(hWnd, wr.RECT)
                EndIf
              Else
                shadow = 0
                GetWindowRect_(hWnd, wr.RECT)
              EndIf;OSver
              If Themed = 1
                hBitmap = CreateImage(0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow,32,#PB_Image_Transparent )
              Else
                hBitmap = CreateImage(0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow)
              EndIf
              hdc = StartDrawing(ImageOutput(0))
              SelectObject_(hdc, hBitmap)
              BitBlt_(hdc,0,0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow, GetDC_(0),wr\left-shadow,wr\top-shadow,#SRCCOPY |#CAPTUREBLT)
              StopDrawing()
              UsePNGImageEncoder()
              
              d.s=FormatDate("%yyyy-%mm-%dd,%hh_%ii_%ss", Date())
              
              If spa=""
                StandardFile$ = d+".png"
                Pattern$ = "Portable Network Graphics (*.png)"
                Pattern = 0
                File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
                If File$<>""
                  spa=GetPathPart(File$)
                EndIf
              EndIf
              
              If spa<>""
                If SaveImage(0,spa+d+".png",#PB_ImagePlugin_PNG)
                  ;Sleep_(10000)
                  PlaySound(0)
                Else
                  MessageRequester("Print Screen","cannot write image"+#CRLF$+spa+d+".png",#PB_MessageRequester_Ok)
                EndIf
              EndIf
            Else
              MessageRequester("Print Screen","cannot find active window",#PB_MessageRequester_Ok)
            EndIf
        EndSelect
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #b_ok
            UnregisterHotKey_(WindowID(0),0)
            
            mods.l=#MOD_ALT*GetGadgetState(#c_alt)
            mods=mods|(#MOD_WIN*GetGadgetState(#c_win))
            mods=mods|(#MOD_CONTROL*GetGadgetState(#c_ctrl))
            mods=mods|(#MOD_SHIFT*GetGadgetState(#c_shift))
            wHotkey = SendMessage_(hwndHot, #HKM_GETHOTKEY, 0, 0)
            If RegisterHotKey_(WindowID(0),0,mods,wHotkey)
              hint=Space(100)
              key = MapVirtualKeyEx_(whotkey&$FF,0,locale)<<16 
              GetKeyNameText_(key,@hint,100)
              
              If GetGadgetState(#c_alt)
                hint="Alt+"+hint
              EndIf
              If GetGadgetState(#c_win)
                hint="Win+"+hint
              EndIf
              If GetGadgetState(#c_ctrl)
                hint="Control+"+hint
              EndIf
              If GetGadgetState(#c_shift)
                hint="Shift+"+hint
              EndIf
              SysTrayIconToolTip (1, "wnd max,"+hint)
              If CreateFile(0,"mw.dat")
                WriteLong(0,war)
                WriteLong(0,wHotkey)
                WriteLong(0,mods)
                WriteString(0,hint)
                CloseFile(0)
                HideWindow(0,1)
              Else
                MessageRequester("Hotkey","Error write file",#PB_MessageRequester_Ok )
              EndIf
            Else
              MessageRequester("Hotkey","Cannot register hotkey",#PB_MessageRequester_Ok )
            EndIf
            
        EndSelect
        
      Case #PB_Event_SysTray
        If EventType() = #PB_EventType_RightClick 
          DisplayPopupMenu(0, WindowID(0)) 
        EndIf 
        
      Case #PB_Event_Menu
        Select EventMenu() 
          Case 3
            war=1-war
            SetMenuItemState(0, 3, war)
            If war
              reg_wa()
            Else
              UnregisterHotKey_(WindowID(0),3)
              UnregisterHotKey_(WindowID(0),4)
              UnregisterHotKey_(WindowID(0),5)
            EndIf

          Case 1
            HideWindow(0,0,#PB_Window_NoActivate)
            SetFocus_(hwndHot)
          Case 2 ; Quit 
            Quit = 1 
        EndSelect 
      Case #PB_Event_CloseWindow
        HideWindow(0,1)
    EndSelect
    
  Until Quit = 1
  FreeSound(0)

  RemoveSysTrayIcon(1)
  UnregisterHotKey_(WindowID(0),0)
EndIf

DataSection
  cl:
  IncludeBinary "click (6).wav"
  ;IncludeBinary "Clksound.wav"
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 97
; FirstLine = 62
; Folding = -
; EnableXP
; UseIcon = mw.ico
; Executable = mw.exe
; CommandLine = D:\