﻿Enumeration
  #c_alt
  #c_win
  #c_shift
  #c_ctrl
  #b_ok
EndEnumeration

Global TaskbarRestart = RegisterWindowMessage_("TaskbarCreated")  ; Register a message with the "TaskbarCreated" string
Global hicon.l

Procedure.l WindowCallback(hwnd,message,wparam,lparam)
Protected result.l=#PB_ProcessPureBasicEvents
 Select message
  Case taskbarrestart
   AddSysTrayIcon (1, WindowID(0), hicon)
 EndSelect
ProcedureReturn result
EndProcedure

#HotKeyGadget = 99 ; or whatever, just remember this is a #gadget so don't reuse it
If OpenWindow(0, 100, 200, 200, 60, "Window Maxinizer",#PB_Window_Invisible|#PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget);,#PB_Window_BorderLess|#PB_Window_Invisible);| #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget) 
  
  SetWindowCallback(@WindowCallback(),0)
  hwndHot = CreateWindowEx_(0,"msctls_hotkey32","",#WS_CHILD|#WS_VISIBLE,0,0,200,20,WindowID(0),#HotkeyGadget,GetModuleHandle_(0),0)
  
  ;SendMessage_(hwndHot,#HKM_SETRULES,HKCOMB_NONE)
  
  CheckBoxGadget(#c_alt,0,20,40,20,"Alt")
  CheckBoxGadget(#c_win,40,20,40,20,"Win")
  CheckBoxGadget(#c_shift,80,20,40,20,"Shift")
  CheckBoxGadget(#c_ctrl,120,20,40,20,"Ctrl")
  ButtonGadget(#b_ok,0,40,200,20,"OK")
  If CreatePopupMenu(0) 
    MenuItem(1, "setup")
    MenuItem(3, "WinAmp remote")
    MenuBar() 
    MenuItem(2, "Quit") 
  EndIf  
  
  hint.s=""
  hicon=LoadIcon_(GetModuleHandle_(0),1)
  AddSysTrayIcon (1, WindowID(0), hicon)
  
  If ReadFile(0,"mw.dat")
    ;RegisterHotKey_(WindowID(0),0,#MOD_WIN|#MOD_ALT,#VK_Z)
    vk.l=ReadLong(0)
     mods.l=0
;     For i=0 To 3
;      mods=mods|ReadLong(0)
      mods=ReadLong(0)
;    Next i
    hint.s=ReadString(0)
    CloseFile(0)
  Else
    MessageRequester("Settings","File 'mw.dat' not found",#PB_MessageRequester_Ok )
    vk.l=#VK_Z
    mods.l=#MOD_WIN|#MOD_ALT
    hint.s="Win+Alt+Z"
  EndIf
  
  If Not RegisterHotKey_(WindowID(0),0,#MOD_WIN|#MOD_ALT,#VK_Z)
    MessageRequester("Hotkey","Cannot register hotkey",#PB_MessageRequester_Ok )
    End
  EndIf
  
  SysTrayIconToolTip (1, "wnd max,"+hint)
  Repeat 
    
    EventID.l = WaitWindowEvent() 
    
  If GetAsyncKeyState_(#VK_ESCAPE)=-32767
    HideWindow(0,1)
  EndIf

    Select EventID
      Case #WM_HOTKEY;If EventID =#WM_HOTKEY
        hwnd.l=GetForegroundWindow_()
        If hwnd
          ShowWindow_(hwnd,#SW_MAXIMIZE)
        EndIf
        ;EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #b_ok
            UnregisterHotKey_(WindowID(0),0)
            
            mods.l=#MOD_ALT*GetGadgetState(#c_alt)
            mods=mods|(#MOD_WIN*GetGadgetState(#c_win))
            mods=mods|(#MOD_CONTROL*GetGadgetState(#c_ctrl))
            mods=mods|(#MOD_SHIFT*GetGadgetState(#c_shift))
            wHotkey = SendMessage_(hwndHot, #HKM_GETHOTKEY, 0, 0)
            If RegisterHotKey_(WindowID(0),0,mods,wHotkey)
              hint=Space(100)
              key = MapVirtualKeyEx_(whotkey&$FF,0,locale)<<16 
              GetKeyNameText_(key,@hint,100)
              
              If GetGadgetState(#c_alt)
                hint="Alt+"+hint
              EndIf
              If GetGadgetState(#c_win)
                hint="Win+"+hint
              EndIf
              If GetGadgetState(#c_ctrl)
                hint="Control+"+hint
              EndIf
              If GetGadgetState(#c_shift)
                hint="Shift+"+hint
              EndIf
              SysTrayIconToolTip (1, "wnd max,"+hint)
              If CreateFile(0,"mw.dat")
                WriteLong(0,wHotkey)
                WriteLong(0,mods)
                WriteString(0,hint)
                CloseFile(0)
                HideWindow(0,1)
              Else
                MessageRequester("Hotkey","Error write file",#PB_MessageRequester_Ok )
              EndIf
            Else
              MessageRequester("Hotkey","Cannot register hotkey",#PB_MessageRequester_Ok )
            EndIf
            
        EndSelect
        
      Case #PB_Event_SysTray;If EventID = #PB_Event_SysTray ; <<-- PopUp bei click auf rechter Maustaste auf Dein Systray Icon 
        If EventType() = #PB_EventType_RightClick 
          DisplayPopupMenu(0, WindowID(0)) 
        EndIf 
        ;EndIf 
        
      Case #PB_Event_Menu;If EventID = #PB_Event_Menu ; <<-- PopUp Event 
        Select EventMenu() 
          Case 1
            HideWindow(0,0,#PB_Window_NoActivate)
            SetFocus_(hwndHot)
          Case 3 ; winamp remote
          Case 2 ; Quit 
            Quit = 1 
        EndSelect 
        ;EndIf 
        
      Case #PB_Event_CloseWindow ;If EventID = #PB_Event_CloseWindow 
                                 ;Quit = 1 
        HideWindow(0,1)
        ;EndIf 
    EndSelect
    
  Until Quit = 1
  RemoveSysTrayIcon(1)
  UnregisterHotKey_(WindowID(0),0)
EndIf

DataSection
  cl:
  IncludeBinary "click6.wav"
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 156
; FirstLine = 115
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = favicon-1.ico
; Executable = mw.exe
; CommandLine = D:\